<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class Json extends CI_Model
{
    function __construct()
    {
        parent::__construct();
    }
    
	/*
	 * get Contacts
	 */
    function Get_contact()
    {
        return $this->db->get('contact')->row_array();
    }
    
	/*
	 * get Categories
	 */
    function Get_Categories()
    {
        $this->db->where(array('Parent_id'=>0 , 'Active'=>1));
        return $this->db->get('categories')->result();
    }
    
	/* 
	 * get  sheikh list
	 */
    function Get_sheikh_join($catId,$limit,$start)//$sheikh_type,
    {
        $this->db->select('*');
        $this->db->from('sheikh');
        $this->db->order_by('Datee','desc');
        $this->db->join('content', 'content.sheikh_id = sheikh.sheikh_id');
        $this->db->where('content.catid',$catId);
        $this->db->distinct('content.sheikh_id');
        $this->db->group_by('content.sheikh_id');
        $this->db->limit($limit,$start);
        return $this->db->get()->result();
    }
    
	/* 
	 * get  sheikh details
	 */
    function Get_sheikh_details($sheikhId)
    {
        $this->db->where('sheikh_id',$sheikhId);
        return $this->db->get('sheikh')->row_array();
    }
    
	/* 
	 * get  content details
	 */
    function Get_content_details($contentId)
    {
        $this->db->where('id',$contentId);
        return $this->db->get('content')->result();
    }
    
	/* 
	 * get content list
	 */
    function Get_content($catId,$sheikhId,$limit,$start)
    {
        $this->db->where('sheikh_id',$sheikhId);
        $this->db->where('catid',$catId);
        $this->db->order_by('add_date','desc');
        return $this->db->get('content',$limit,$start)->result();
    }
    
	/* 
	 * get content list
	 */
    function Get_child_content($parentId)
    {
        $this->db->where('parent_id',$parentId);
        $this->db->order_by('add_date','desc');
        return $this->db->get('content',$limit,$start)->result();
    }    
    
	/* 
	 * get count content related to parent_id in content table
	 */
    
    function count_chiled_content($contentId)
    {
        $this->db->where('parent_id',$contentId);
        return $this->db->count_all_results('content');
    }  
    
	/* 
	 * get count content related to specific sheikh and category in content table
	 */
    
    function count_sheikh_category_content($sheikhId,$catId)
    {
        $this->db->where('sheikh_id',$sheikhId);
        $this->db->where('catid',$catId);
        return $this->db->count_all_results('content');
    }
    
	/* 
	 * get last date for content added or updated for specific sheikh in content table
	 */
    
    function get_sheikh_content_max_date($sheikhId)
    {
        $this->db->where('sheikh_id',$sheikhId);
        $this->db->select_max('update_date');
        return $this->db->get('content')->row('update_date');
    }
    
    
	/* 
	 * get last date for content added or updated for specific Matn content in content table
	 */
    
    function get_chiled_content_max_date($contentId)
    {
        $this->db->where('parent_id',$contentId);
        $this->db->select_max('update_date');
        return $this->db->get('content')->row('update_date');
    }
    
	/* 
	 * get content translate sheikhs list
	 */
    
    function Get_translate_sheikhs($catId,$limit,$start)
    {
        $this->db->where('catid',$catId);
        $this->db->order_by('add_date','desc');
        return $this->db->get('content',$limit,$start)->result();
    }
}