<?php
if (!defined('BASEPATH'))
    exit('No direct script access allowed');
class Categories extends CI_Controller
{
    function __construct()
    {
        parent::__construct();
        $this->init->admin_init();
		$this->init->get_perm();
		$this->load->library('crumb');
    }
    /*
     * Function to shwo grid
     */
    function _example_output($output = null)
    {
        //$output['breadcrumb'] = $this->load->crumb->get_crumbs(1,"/", lang('categories'));
        $this->load->view('base/header', true);
        $this->load->view('base/grid',$output);
        $this->load->view('base/footer',true);
    }
    /*
     * Function to set grid
     */
    function index()
    {
        $crud = new grocery_CRUD();
        /*
         *  Set table
         */
        $crud->set_table('categories');
        /*
         *  Set subject
         */
        $crud->set_subject(lang('category'));
        /*
         *  Where condition
         */
         $crud->where('categories.archived',0);
        /*
         * Set relation
         */
        $crud->set_relation('Type','category_types','Type_name_ar',array('Active'=>'1'));
        /* 
         * Add this customisation for parent_relation 
         */
        $primary_id_field           = 'Category_id';        //$primary_id_field  is the primary key of your table
        $table_name 		= 'categories';         //$table_name is the name of our table
        $relation_field_name        = 'Parent_id';          //$relation_field_name  is the name of field in the first table related to second table 
        $parent_field 		= 'Parent_id';          //$parent_field   is the parent field name
        //if($this->session->userdata('adminlang') == 'arabic')
        if($this->config->item('multi_lang')==0)
        {
            $title_field 		= 'Name';      //$title_field is the title field that you want to appear from the table
        }else
        {
            $title_field 		= 'Name_en';      //$title_field is the title field that you want to appear from the table
        }
        $title_display_as 	= lang('Name')  ;             //$title_display_as  the string that it will show
        $where			= array('Active'=>'1');//not required ----- condition
        $same_table 		= false; //not required, the default is false
        $crud->set_parent_relation($primary_id_field,$table_name,$parent_field,$title_field,$crud,$title_display_as,$relation_field_name,$where,$same_table);
        /* ------------------------------------------- */
        /*
         *  Set rulse
         */
        /*
         *  Display fields as
         */
        $crud->display_as('Parent_id',lang('following_to'));
        $crud->display_as('Name',lang('name_ar'));
        $crud->display_as('Image',lang('image'));
        $crud->display_as('Description',lang('description_ar'));
        $crud->display_as('Creat_date',lang('creat_date'));
        $crud->display_as('Active',lang('activation'));
        $crud->display_as('Type',lang('Type'));
        /*
         *  Where condition
         */
        /*
         *  Columns
         */
        if($this->config->item('multi_lang')==0)
        {
            $crud->columns('Name','Type','Image','Active');
        }
        /*
         *  Fields
         */
        $crud->Fields('Type','Name','Image','Active');
        /*
         * Upload field
         */
        $crud->set_field_upload('Image','assets/uploads');
        /*
         *  Required fields
         */
        $crud->required_fields('Name');
        /*
         *  Types of fields
         */
        $crud->field_type('Creat_date','hidden',date('Y-m-d H:i:s' , strtotime(mktime())));
        
        //$crud->field_type('Active', 'hidden', 1);
        $crud->field_type('Parent_id', 'hidden', 0);
        /*
         *  Callback functions
         */
        /*
         *  Callback columns        
         */
        $crud->callback_column('Active',array($this,'callback_column_valid'));
        $crud->callback_column('Order_by',array($this,'callback_column_order_by'));
        $crud->callback_column('Allow_comment',array($this,'callback_column_allow_comment'));
        $crud->callback_column('Active_comment',array($this,'callback_column_active_comment'));
        /*
         *  Callback fields
         */
         //$crud->callback_before_delete(array($this,'check_content'));
        $crud->unset_delete();
        // Add some Actions to the data grid
        $crud->add_action(lang('').'delete', base_url().'/assets/grocery_crud/themes/flexigrid/css/images/close.png',  base_url().ADMIN_MODULE.'/categories/delete/');
        
        //$crud->callback_add_field('Parent_id',array($this,'add_select_Parent_id'));
        //$crud->callback_edit_field('Parent_id',array($this,'edit_select_Parent_id'));
        $crud->callback_add_field('Active',array($this,'callback_add_field_valid'));
        $crud->callback_edit_field('Active',array($this,'callback_edit_field_valid'));
        $crud->callback_add_field('Order_by',array($this,'callback_add_field_order_by'));
        $crud->callback_edit_field('Order_by',array($this,'callback_edit_field_order_by'));
        $crud->callback_add_field('Allow_comment',array($this,'callback_add_allow_comment'));
        $crud->callback_edit_field('Allow_comment',array($this,'callback_edit_allow_comment'));
        $crud->callback_add_field('Active_comment',array($this,'callback_add_field_active_comment'));
        $crud->callback_edit_field('Active_comment',array($this,'callback_edit_field_active_comment'));
        /* 
         * Users Permissions
         */
        if(@$this->session->userdata('perm')->{$this->uri->segment(2)}->{$this->uri->segment(2).'add'}!=1)
		{
			$crud->unset_add();
		}
		if(@$this->session->userdata('perm')->{$this->uri->segment(2)}->{$this->uri->segment(2).'edit'}!=1)
		{
			$crud->unset_edit();
		}
		if(@$this->session->userdata('perm')->{$this->uri->segment(2)}->{$this->uri->segment(2).'del'}!=1)
		{
			$crud->unset_delete();
		}
        /*
         * Unset Functions
         */         
         $crud->unset_print();
         $crud->unset_export();
         
        /*
         *  Render data grid  (output)
         */
        $output = $crud->render();
        $this->_example_output($output);
    }
    /*
     * Function to delete data if there is no content related to it 
     */
    function delete($primary_key)
    {
        $this->load->model('base_model');
        $check_content = $this->base_model->check_content('catid',$primary_key);
        if($check_content)
        {
            //return false;//"<script> alert('???? ?????');</script>";
            $this->session->set_flashdata('message','???? ????? .. ????? ??? ??????? ????');
            //redirect(base_url().'Base/sheikh', 'refresh');
        }else{
            $this->base_model->update_data('categories','Category_id',$primary_key);
        }
        redirect(base_url().'Base/categories', 'refresh');
    }
    /*
     * Function to show valid column in a specific way 
     */
    function callback_column_valid($value)
    {
        if ($value == '0')
        {
            return ' - ';
        }
        else
        {
            return img(array('src' => base_url().'assets/images/icons/16x16/success.png'));
        }
    }
    /*
     * Function to show valid field in a specific way (add -- edit)
     */
    function callback_add_field_valid()
    {
        return '<input type="radio" name="Active" id="Active" value="1" />'."     ".lang('active')."     ".
                '<input type="radio" name="Active" id="Active" value="0" />'."     ".lang('unactive');
    }
    function callback_edit_field_valid($value)
    {
        if ($value == '1')
        {
            $active = 'checked="checked"';
            $unactive = '';
        }
        elseif($value == '1')
        {
            $active = '';
            $unactive = 'checked="checked"';
        }
        return '<input type="radio" name="Active" id="Active" '.$active.' value="1" />'."     ".lang('active')."     ".
                '<input type="radio" name="Active" id="Active" '.$unactive.' value="0" />'."     ".lang('unactive');
    }
    /*
     * Function to show Order_by column in a specific way 
     */
    function callback_column_order_by($value)
    {
        if ($value == 'desc')
        {
            return lang('desc');
        }
        elseif($value == 'asc')
        {
            return lang('asc');
        }
    }
    /*
     * Function to show Order_by field in a specific way (add -- edit)
     */
    function callback_add_field_order_by()
    {
        return '<input type="radio" name="Order_by" id="Order_by" value="desc" />'."     ".lang('desc')."     ".
                '<input type="radio" name="Order_by" id="Order_by" value="asc" />'."     ".lang('asc');
    }
    function callback_edit_field_order_by($value)
    {
        if ($value == 'desc')
        {
            $active = 'checked="checked"';
            $unactive = '';
        }
        elseif($value == 'asc')
        {
            $active = '';
            $unactive = 'checked="checked"';
        }
        return '<input type="radio" name="Order_by" id="Order_by" '.$active.' value="desc" />'."     ".lang('desc')."     ".
                '<input type="radio" name="Order_by" id="Order_by" '.$unactive.' value="asc" />'."     ".lang('asc');
    }
    /*
     * Function to show Allow_comment column in a specific way 
     */
    function callback_column_allow_comment($value)
    {
        if ($value == '0')
        {
            return ' - ';
        }
        else
        {
            return img(array('src' => base_url().'assets/images/icons/16x16/success.png'));
        }
    }
    /*
     * Function to show Allow_comment field in a specific way (add -- edit)
     */
    function callback_add_allow_comment()
    {
        return '<input type="radio" name="Allow_comment" id="Allow_comment" value="1" />'."     ".lang('avilable')."     ".
                '<input type="radio" name="Allow_comment" id="Allow_comment" value="0" />'."     ".lang('unavilable');
    }
    function callback_edit_allow_comment($value)
    {
        if ($value == '1')
        {
            $active = 'checked="checked"';
            $unactive = '';
        }
        elseif($value == '1')
        {
            $active = '';
            $unactive = 'checked="checked"';
        }
        return '<input type="radio" name="Allow_comment" id="Allow_comment" '.$active.' value="1" />'."     ".lang('avilable')."     ".
                '<input type="radio" name="Allow_comment" id="Allow_comment" '.$unactive.' value="0" />'."     ".lang('unavilable');
    }
    /*
     * Function to show Active_comment column in a specific way 
     */
    function callback_column_active_comment($value)
    {
        if ($value == '0')
        {
            return lang('directly');
        }
        else
        {
            return lang('administrator');
        }
    }
    /*
     * Function to show Active_comment field in a specific way (add -- edit)
     */
    function callback_add_field_active_comment()
    {
        return '<input type="radio" name="Active_comment" id="Active_comment" value="1" />'."     ".lang('directly')."     ".
                '<input type="radio" name="Active_comment" id="Active_comment" value="0" />'."     ".lang('administrator');
    }
    function callback_edit_field_active_comment($value)
    {
        if ($value == '1')
        {
            $active = 'checked="checked"';
            $unactive = '';
        }
        elseif($value == '1')
        {
            $active = '';
            $unactive = 'checked="checked"';
        }
        return '<input type="radio" name="Active_comment" id="Active_comment" '.$active.' value="1" />'."     ".lang('directly')."     ".
                '<input type="radio" name="Active_comment" id="Active_comment" '.$unactive.' value="0" />'."     ".lang('administrator');
    }
	/*
	 * Ajax FUNCTION WITH MULTILINE FIELD
	 */
    function add_select_Parent_id()
    {
        return '<script>
            $("#Type_input_box select").change(function(){
                $.ajax({
                    url : "'.base_url().'Admin/categories/ajax_category/"+$("#Type_input_box select").val(),
                    success : function(data){
                    $("#Parent_id_input_box").html(data);
                    }
                });
            });
                $.ajax({
                    url : "'.base_url().'Admin/categories/ajax_category/"+$("#Type_input_box select").val(),
                    success : function(data){
                     $("#Parent_id_input_box").html(data);
                    }
                });
        </script>';
    }
    function edit_select_Parent_id($primary_key,$value)
    {
       return '<script>
            $("#Type_input_box select").change(function(){
                $.ajax({
                    url : "'.base_url().'Admin/categories/ajax_category_edit/"+$("#Type_input_box select").val()+"/'.$value.'"+"/'.$this->uri->segment(5).'",
                    success : function(data){
                     $("#Parent_id_input_box").html(data);
                    }
                });
            });
              $.ajax({
                    url : "'.base_url().'Admin/categories/ajax_category_edit/"+$("#Type_input_box select").val()+"/'.$value.'"+"/'.$this->uri->segment(5).'",
                    success : function(data){
                     $("#Parent_id_input_box").html(data);
                    }
                });
            </script>';
    }
    ////////////////////
    function ajax_category($Type='',$operation='insert')
    {
        echo "<select name='Parent_id'>";
        echo '<option value="0">'.lang('Type').'</option>';
        $this->tree($Type,$operation);
        echo"</select>";
    }
    function ajax_category_edit($Type='',$value,$primary_key,$operation='edit')
    {
        echo "<select name='Parent_id'>";
        echo '<option value="0">'.lang('Type').'</option>';
        $this->tree($Type,$operation,$value,$primary_key);
        echo"</select>";
    }
    function tree($Type,$operation,$value=0,$primary_key=0,$Parent_ID = 0,$no=0)
    {
        $no ++;
        $this->load->model('base_model');
        $select = $this->base_model->select_category($Type,$Parent_ID);
        foreach ($select as $option)
        {
            if($value==$option->Category_id)
            {
                $selected = 'selected="selected"';
                $disabled = 'disabled="disabled"';
            }else{
                $selected = '';
                if($operation == 'insert')
                {
                    if($primary_key == $option->Category_id)// or $primary_key == $option->Parent_id)
                    {
                        $disabled = 'disabled="disabled"';
                    }else{
                        $disabled = '';
                    }
                }else{
                    if($primary_key == $option->Category_id or $primary_key == $option->Parent_id)
                    {
                        $disabled = 'disabled="disabled"';
                    }else{
                        $disabled = '';
                    }
                }
            }
            echo '<option '.$selected.' '.$disabled.' value='. $option->Category_id.'>';
            for($x = 1 ;$x<$no ; $x++) echo " - ";
            echo " | ";
            //if($this->session->userdata('lang')=="arabic")
            //if($this->session->userdata('adminlang') == 'arabic')
            if($this->config->item('multi_lang')==0)
            {
                echo $option->Name;
            }
            //if($this->session->userdata('lang')=="english")
			else
            {
                echo $option->Name_en;
            }
            echo '</option>';
            $this->tree($Type,$operation,$value ,$primary_key, $option->Category_id,$no);
        }
    }
}