<?php

if (!defined('BASEPATH'))

    exit('No direct script access allowed');



class Groups extends CI_Controller

{

    function __construct()

    {

        parent::__construct();

        $this->init->admin_init();

		$this->load->library('crumb');

    }



    function _example_output($output)

    {

        $this->load->view('base/header', true);

        $this->load->view('base/grid',$output);

        $this->load->view('base/footer',true);

    }



	function index()

	{

		$crud = new grocery_CRUD();

        $crud->set_table('groups');

        $crud->set_subject('groups');

		

		$crud->display_as('name',lang('group_name'));

		$crud->display_as('description',lang('group_description'));



		//$crud->set_language(lang('Adminlang'));

				

		$crud->columns('name', 'description');

        $crud->fields('name','description');

        $crud->edit_fields ('name','description');

        $crud->required_fields('name', 'description');

		

        

        /*

         *  Callback functions

         */

        

        ////////////////**log file

		$crud->callback_after_insert(array($this,'log_file_add'));

		$crud->callback_after_update(array($this,'log_file_edit'));

        $crud->callback_after_delete(array($this,'log_file_delete'));

        ///////////////////////////////////////////////////////////// 

        

		$crud->add_action('الصور', '', ADMIN_MODULE . '/groups/permission','ui-icon-image');

			

		$crud->required_fields('name');

		$output = $crud->render();

		$this->_example_output($output);

	}

	

	function permission($ID)

	{

		$this->load->model('base_model');

		$body['modules'] = $this->load->base_model->get_modules();

		$body['permissions'] = json_decode($this->load->base_model->get_module_permission($ID,'Permissions'));

		$body['Group_type'] = json_decode($this->load->base_model->get_module_permission($ID,'Group_type'));

		$body['ID'] = $ID;

		

		$body['breadcrumb'] = $this->load->crumb->get_crumbs(1,"/","dashboard");

        $data['js_files'][]=base_url().'assets/grocery_crud/js/jquery-1.8.2.min.js';

        //$bread['breadcrumb']='<a href="'.base_url().'Base/user">home</a>';

        $this->load->view('base/header',$data);

        $this->load->view('permissions',$body);

        $this->load->view('base/footer');

	}

	

	function save_permission()

	{

		$this->load->model('base_model');

		$group_id = $this->input->post('group_id');

		$modules = $this->load->base_model->get_modules();

			foreach ($modules as $m)

			{

            	$a[$m->U_name]=array($m->U_name."view" => $this->input->post($m->U_name.'view'),

									 $m->U_name."add"  => $this->input->post($m->U_name.'add'),

									 $m->U_name."edit" => $this->input->post($m->U_name.'edit'),

									 $m->U_name."del"  => $this->input->post($m->U_name.'del')

								);

			}

		

		//id 	name 	description 	Permissions 	Group_type

		$dat = json_encode($a);

		

		$data = array(

            'Permissions' => $dat,

            'Group_type' => $group_id

        );

		

		$this->db->where('id', $group_id);

		$this->db->update('groups', $data); 

		redirect(ADMIN_MODULE . '/groups/permission/'.$this->input->post('group_id'));

	}

    

    function log_file_add($row,$primary_key )

    {

		$data=array(

				   'user_id'=>$this->ion_auth->user()->row()->id,

				   'user_name'=>$this->ion_auth->user()->row()->username,

				   'operation'=>'اضافه',

				   'module_operation'=>'التصنيفات',

				   'operationen'=>'ADD',

				   'module_operationen'=>'Categories',

				   'action_nameen'=>$row['name'],

				   'action_id'=>$primary_key,

				   'datee'=>mktime(),

				   'action_name'=>$row['name']

				   );			   

        $this->log_file->save($data);

    }

    

    function log_file_edit($row,$primary_key )

    {

		$data=array(

				   'user_id'=>$this->ion_auth->user()->row()->id,

				   'user_name'=>$this->ion_auth->user()->row()->username,

				   'operation'=>'تعديل',

				   'module_operation'=>'التصنيفات',

				   'operationen'=>'Edit',

				   'module_operationen'=>'Categories',

				   'action_nameen'=>$row['name'],

				   'action_id'=>$primary_key,

				   'datee'=>mktime(),

				   'action_name'=>$row['name']

				   );			   

        $this->log_file->save($data);

    }

    

    function log_file_delete($primary_key )

    {

		$data=array(

				   'user_id'=>$this->ion_auth->user()->row()->id,

				   'user_name'=>$this->ion_auth->user()->row()->username,

				   'operation'=>'حذف',

				   'operationen'=>'Delete',

				   'module_operationen'=>'Categories',

				   'module_operation'=>'التصنيفات',

				   'action_id'=>$primary_key,

				   'datee'=>mktime(),		   

				   );			   

        $this->log_file->save($data);

    }

}