<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');



class Login extends CI_Controller 

{

    function __construct() 

    {

        parent::__construct();

    }

    /**

     * Index Page for this controller.

     * Check if logged in .. redirect to dashboard 

     * If not logged redirect to log in page

    */

    public function index()

    {

        if ($this->ion_auth->logged_in())

		{

            redirect('Base/dashboard', 'refresh');

            //$this->load->view('welcome_message');

		}

        else

        {

            //validate form input

            $this->form_validation->set_rules('identity', 'Identity', 'required|valid_email');

            $this->form_validation->set_rules('password', 'Password', 'required');



            if ($this->form_validation->run() == true)

            {

                //check to see if the user is logging in

                //check for "remember me"

                $remember = (bool) $this->input->post('remember');



                if ($this->ion_auth->login($this->input->post('identity'), $this->input->post('password'), $remember))

                {

                    //if the login is successful

                    //redirect them back to the home page



                    $this->session->set_flashdata('message', $this->ion_auth->messages());

                    redirect('Base/dashboard', 'refresh');

                    //$this->load->view('welcome_message');

                    //redirect('/', 'refresh');

                }

                else

                {

                    //if the login was un-successful

                    //redirect them back to the login page

                    $this->data['message'] = $this->session->set_flashdata('message', $this->ion_auth->errors());

                    $this->data['identity'] = array('name' => 'identity',

                    'id' => 'identity',

                    'type' => 'text',

                    'value' => $this->form_validation->set_value('identity'),

                    'class'=>'span12'

                    );

                    $this->data['password'] = array('name' => 'password',

                        'id' => 'password',

                        'type' => 'password',

                        'class'=>'span12'

                        );



                    //$this->load->view('login', $this->data);

                    $content['showpage'] = $this->load->view('login', $this->data);

                    $this->load->view('special_page', $content);

                    //redirect('Base/login', 'refresh'); //use redirects instead of loading views for compatibility with MY_Controller libraries

                }

            }

            else

            {

                //the user is not logging in so display the login page

                //set the flash data error message if there is one

                $this->data['message'] = (validation_errors()) ? validation_errors() : $this->session->flashdata('message');



                $this->data['identity'] = array('name' => 'identity',

                    'id' => 'identity',

                    'type' => 'text',

                    'value' => $this->form_validation->set_value('identity'),

                    'class'=>'span12'

                    );

                $this->data['password'] = array('name' => 'password',

                    'id' => 'password',

                    'type' => 'password',

                    'class'=>'span12'

                    );

                

                $this->load->view('login', $this->data);

                //$content['showpage'] = $this->load->view('login', $this->data);

                //$this->load->view('special_page', $content);

            }

        }

    }

}



/* End of file Login.php */

/* Location: ./application/modules/Base/controllers/welcome.php */