<?php 
if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class Moton extends CI_Controller
{
    function __construct()
    {
        parent::__construct();
        $this->init->admin_init();
		$this->load->library('crumb');
		$this->init->get_perm();
    }
    /**
     * Index Page for this controller.
     * redirect to dashboard
    */

    function _example_output($output = null)
    {
        $this->load->view('base/header', true);
        $this->load->view('base/grid',$output);
        $this->load->view('base/footer',true);
    }
    
    function index()
    {
        $crud = new grocery_CRUD();
        $crud->set_table('content');
        
        /*
         *  Set subject
         */
        $crud->set_subject('متن');
        $crud->set_relation('sheikh_id', 'sheikh', 'sheikh_name');//,array('type'=>'sheikh')
        $crud->set_relation('sheikh_type', 'sheikh', 'type');
        $crud->set_relation('catid', 'categories', 'Name',array('Type'=>'5'));
		
		//$crud->set_relation_n_n('group_id', 'users_groups', 'groups', 'user_id', 'group_id', 'name');
        /*
         *  Where condition
         */
         //$crud->where('sheikh_type','sheikh');
         $crud->where('cattype',5);
         $crud->where('content.parent_id',0);
         $crud->where('content.archived',0);
         //$crud->where(array('sheikh_type'=>'scientist','cattype'=>1));
        /*
         *  Display fields as
         */
        $crud->display_as('catid',lang('following_to'));
        $crud->display_as('sheikh_id','الشيخ');
        $crud->display_as('auther','الناشر');
        $crud->display_as('name',lang('name_ar'));
        $crud->display_as('pic',lang('image'));
        $crud->display_as('file_path','الملف');
        $crud->display_as('file_size','حجم الملف');
        $crud->display_as('file_period','المدة');
        $crud->display_as('details',lang('news_details'));
        $crud->display_as('viewitem',lang('activation'));
        $crud->display_as('morefile','إضافة مواد صوتية');
        
        /* 
         * Add this customisation for parent_relation 
         /
        $primary_id_field   = 'Category_id';        //$primary_id_field  is the primary key of your table
        $table_name 		= 'categories';         //$table_name is the name of our table
        $relation_field_name= 'catid';          //$relation_field_name  is the name of field in the first table related to second table 
        $parent_field 		= 'Parent_id';          //$parent_field   is the parent field name
        if($this->config->item('multi_lang')==0)
        {
            $title_field 	= 'Name';      //$title_field is the title field that you want to appear from the table
        }else{
            $title_field 	= 'Name_en';      //$title_field is the title field that you want to appear from the table
        }
        $title_display_as 	= lang('Name')  ;             //$title_display_as  the string that it will show
        $where			= array('Active'=>'1','Type'=>'1');//not required ----- condition
        $same_table 		= false; //not required, the default is false
        $crud->set_parent_relation($primary_id_field,$table_name,$parent_field,$title_field,$crud,$title_display_as,$relation_field_name,$where,$same_table);
        /* ------------------------------------------- */
		
		//'name','slug','catid','pic','details','viewitem','featureditem','writer_name','artsource','add_date','user_created'
		$crud->columns('name', 'catid','sheikh_id','auther','viewitem');//, 'featureditem', 'writer_name', 'vists');
        $crud->fields('catid','sheikh_id','name','pic','viewitem','cattype');//,'details','add_date','featureditem','writer_name','artsource'
        $crud->edit_fields ('catid','sheikh_id','name','pic','viewitem','cattype');//,'details','user_created','add_date','featureditem','writer_name','artsource'
        $crud->required_fields('name', 'catid');
		$crud->callback_column('viewitem',array($this,'activevalue'));	
		//$crud->callback_column('featureditem',array($this,'activevalue'));	
        $crud->set_field_upload('pic', 'assets/uploads/');	
        $crud->set_field_upload('file_path', 'assets/uploads/');
        
        
        //$crud->add_action('إضافة تسجيلات', base_url().'assets/images/add.png', '','ui-icon-image',array($this,'morefile'));
        $crud->add_action('إضافة تسجيلات', base_url().'assets/images/add.png', 'Base/moton/morefiles_management','ui-icon-plus');
        
        /*
         *  Hidden fields
         */
         //$crud->field_type('sheikh_type', 'hidden', 'sheikh');        
         $crud->field_type('cattype', 'hidden', 5);        
         $crud->field_type('viewitem', 'hidden', 1);
         $crud->field_type('add_date', 'hidden', date('Y-m-d H:i:s' , mktime()));
         
         //$crud->callback_column('morefile',array($this,'morefile'));
        
        /*
         * Unset Functions
         */         
         $crud->unset_print();
         $crud->unset_export();
         

		if(@$this->session->userdata('perm')->{$this->uri->segment(2)}->{$this->uri->segment(2).'add'}!=1)
		{
			$crud->unset_add();
		}
		
		if(@$this->session->userdata('perm')->{$this->uri->segment(2)}->{$this->uri->segment(2).'edit'}!=1)
		{
			$crud->unset_edit();
		}
		
		if(@$this->session->userdata('perm')->{$this->uri->segment(2)}->{$this->uri->segment(2).'del'}!=1)
		{
			$crud->unset_delete();
		}
		
        $output = $crud->render();
        $this->_example_output($output);
			
    }
	
	function activevalue($value, $row)
	{
		if($value ==0)
		{
			return ;
		}elseif($value ==1) 
		{
			return   img(array('src'=>base_url().'assets/images/ok.png'));     
		}	
	}
    
    function morefile($primary_key , $row)
	{
	   return  anchor('Base/moton/morefiles_management/'.$primary_key.'/'.$row->catid);  
    }
    
    function morefiles_management($parent_id)
    {
        $crud = new grocery_CRUD();
        $crud->set_table('content');
        
        $crud->set_subject('مادة صوتية');
        $crud->set_relation('parent_id','content','name');
        $crud->set_relation('sheikh_id', 'sheikh', 'sheikh_name');
        $crud->set_relation('sheikh_type', 'sheikh', 'type');
        $crud->set_relation('catid', 'categories', 'Name',array('Type'=>'5'));
        /* 
         * Add this customisation for parent_relation 
         /
        $primary_id_field           = 'id';        //$primary_id_field  is the primary key of your table
        $table_name 		= 'content';         //$table_name is the name of our table
        $relation_field_name        = 'parent_id';          //$relation_field_name  is the name of field in the first table related to second table 
        $parent_field 		= 'parent_id';          //$parent_field   is the parent field name
        $title_field 		= 'Name';      //$title_field is the title field that you want to appear from the table
        $title_display_as 	= 'تابع لـ'  ;             //$title_display_as  the string that it will show
        $where			= array('viewitem'=>'1');//not required ----- condition
        $same_table 		= false; //not required, the default is false
        $crud->set_parent_relation($primary_id_field,$table_name,$parent_field,$title_field,$crud,$title_display_as,$relation_field_name,$where,$same_table);
        /* ------------------------------------------- */
        
        $crud->where("content.parent_id = $parent_id");

        $crud->columns('parent_id','name','sheikh_id');
        /*
         *  Display fields as
         */
        $crud->display_as('parent_id',lang('following_to'));
        $crud->display_as('catid',lang('category'));
        $crud->display_as('sheikh_id','القارئ');
        $crud->display_as('auther','الناشر');
        $crud->display_as('name',lang('name_ar'));
        $crud->display_as('pic',lang('image'));
        $crud->display_as('file_path','الملف');
        $crud->display_as('file_size','حجم الملف');
        $crud->display_as('file_period','المدة');
        $crud->display_as('details',lang('news_details'));
        $crud->display_as('viewitem',lang('activation'));
        $crud->display_as('morefile','إضافة مواد صوتية');
        
        $crud->columns('parent_id', 'catid','sheikh_id');//, 'featureditem', 'writer_name', 'vists');
        $crud->fields('parent_id','catid','sheikh_id','auther','pic','file_path','file_size','file_period','viewitem','cattype');
        
        $crud->field_type('parent_id','hidden',$parent_id);
        //$crud->field_type('catid', 'hidden', $catid);      
        $crud->field_type('cattype', 'hidden', 5);        
        $crud->field_type('viewitem', 'hidden', 1);
        $crud->field_type('add_date', 'hidden', date('Y-m-d H:i:s' , mktime()));
        	
        $crud->set_field_upload('pic', 'assets/uploads/');	
        $crud->set_field_upload('file_path', 'assets/uploads/');
       	
        $output = $crud->render();
        $this->_example_output($output);
    }
}