<?php
if (!defined('BASEPATH'))
    exit('No direct script access allowed');
class Sheikh extends CI_Controller
{
    function __construct()
    {
        parent::__construct();
        $this->init->admin_init();
		$this->init->get_perm();
		$this->load->library('crumb');
    }
    /*
     * Function to shwo grid
     */
    function _example_output($output = null)
    {
        //$output['breadcrumb'] = $this->load->crumb->get_crumbs(1,"/", lang('branches'));
        $this->load->view('base/header', true);
        $this->load->view('base/grid',$output);
        $this->load->view('base/footer',true);
    }
    /*
     * Function to set grid
     */
    function index()
    {
        $crud = new grocery_CRUD();
        /*
         *  Set table
         */
        $crud->set_table('sheikh');
        /*
         * Set subject
         */
        $crud->set_subject('شخصية');
        /*
         *  Set rulse
         */
         
        /*
         *  Display fields as
         */
        $crud->display_as('sheikh_name',lang('name'));
        $crud->display_as('sheikh_image',lang('image'));
        $crud->display_as('Active',lang('Active'));
        $crud->display_as('Datee',lang('Datee'));
        $crud->display_as('type',lang('Type'));
        /*
         *  Where condition
         */
         //$crud->where('type','sheikh');
        /*
         *  Columns
         */
         $crud->columns('sheikh_name','type','Datee','Active');
        /*
         *  Fields
         */
         $crud->Fields('sheikh_name','sheikh_image','Active','type','Datee');
        /*
         *  Edit Fields
         */
         $crud->edit_fields('sheikh_name','sheikh_image','Active','type','Datee');
        /*
         *  Required fields
         */
         $crud->required_fields('sheikh_name');
        /*
         *  Hidden fields
         */
         //$crud->field_type('type', 'hidden', 'sheikh');
         $crud->field_type('Active', 'hidden', 1);
         $crud->field_type('Datee', 'hidden', date('Y-m-d H:i:s' , mktime()));
        /*
         *  Callback functions
         */
        $crud->callback_column('Active',array($this,'activevalue'));	
        $crud->set_field_upload('sheikh_image', 'assets/uploads/');
        
        //$crud->callback_before_delete(array($this,'check_content'));
        $crud->unset_delete();
        // Add some Actions to the data grid
        $crud->add_action(lang('').'delete', base_url().'/assets/grocery_crud/themes/flexigrid/css/images/close.png',  base_url().ADMIN_MODULE.'/sheikh/delete/');
        
        ////////////////**log file
		$crud->callback_after_insert(array($this,'log_file_add'));
		$crud->callback_after_update(array($this,'log_file_edit'));
        $crud->callback_after_delete(array($this,'log_file_delete'));
        ///////////////////////////////////////////////////////////// 
        /* 
         * Users Permissions
         */
        if(@$this->session->userdata('perm')->{$this->uri->segment(2)}->{$this->uri->segment(2).'add'}!=1)
		{
			$crud->unset_add();
		}
		if(@$this->session->userdata('perm')->{$this->uri->segment(2)}->{$this->uri->segment(2).'edit'}!=1)
		{
			$crud->unset_edit();
		}
		if(@$this->session->userdata('perm')->{$this->uri->segment(2)}->{$this->uri->segment(2).'del'}!=1)
		{
			$crud->unset_delete();
		}
        /*
         * Unset Functions
         */         
         $crud->unset_print();
         $crud->unset_export();
         
        /*
         *  Render data grid  (output)
         */
        $output = $crud->render();
        $this->_example_output($output);
    }
    function activevalue($value, $row)
	{
		if($value ==0)
		{
			return ;
		}elseif($value ==1) 
		{
			return   img(array('src'=>base_url().'assets/images/ok.png'));     
		}	
	}
    
    function delete($primary_key)
    {
        $this->load->model('base_model');
        $check_content = $this->base_model->check_content('sheikh_id',$primary_key);
        if($check_content)
        {
            //return false;//"<script> alert('يوجد محتوى');</script>";
            $this->session->set_flashdata('message','يوجد محتوى .. برجاء حذف المحتوى أولا');
            //redirect(base_url().'Base/sheikh', 'refresh');
        }else{
            $this->base_model->delete_data('sheikh','sheikh_id',$primary_key);
        }
        redirect(base_url().'Base/sheikh', 'refresh');
    }
    function log_file_add($row,$primary_key )
    {
		$data=array(
				   'user_id'=>$this->ion_auth->user()->row()->id,
				   'user_name'=>$this->ion_auth->user()->row()->username,
				   'operation'=>'إضافة',
				   'module_operation'=>'الشيوخ',
				   'operationen'=>'ADD',
				   'module_operationen'=>'Sheikh',
				   'action_nameen'=>$row['sheikh_name'],
				   'action_id'=>$primary_key,
				   'datee'=>mktime(),
				   'action_name'=>$row['sheikh_name']
				   );			   
        $this->log_file->save($data);
    }
    function log_file_edit($row,$primary_key )
    {
		$data=array(
				   'user_id'=>$this->ion_auth->user()->row()->id,
				   'user_name'=>$this->ion_auth->user()->row()->username,
				   'operation'=>'تعديل',
				   'module_operation'=>'الشيوخ',
				   'operationen'=>'Edit',
				   'module_operationen'=>'Sheikh',
				   'action_nameen'=>$row['sheikh_name'],
				   'action_id'=>$primary_key,
				   'datee'=>mktime(),
				   'action_name'=>$row['sheikh_name']
				   );			   
        $this->log_file->save($data);
    }
    function log_file_delete($primary_key )
    {
		$data=array(
				   'user_id'=>$this->ion_auth->user()->row()->id,
				   'user_name'=>$this->ion_auth->user()->row()->username,
				   'operation'=>'حذف',
				   'operationen'=>'Delete',
				   'module_operationen'=>'Sheikh',
				   'module_operation'=>'الشيوخ',
				   'action_id'=>$primary_key,
				   'datee'=>mktime(),		   
				   );			   
        $this->log_file->save($data);
    }
}