<?php 
if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class Translates extends CI_Controller
{
    function __construct()
    {
        parent::__construct();
        $this->init->admin_init();
		$this->load->library('crumb');
		$this->init->get_perm();
    }
    /**
     * Index Page for this controller.
     * redirect to dashboard
    */

    function _example_output($output = null)
    {
        $this->load->view('base/header', true);
        $this->load->view('base/grid',$output);
        $this->load->view('base/footer',true);
    }
    
    function index()
    {
        $crud = new grocery_CRUD();
        $crud->set_table('content');
        
        /*
         *  Set subject
         */
        $crud->set_subject('تراجم العلماء');
        $crud->set_relation('sheikh_id', 'sheikh', 'sheikh_name');//,array('type'=>'scientist')
        $crud->set_relation('catid', 'categories', 'Name',array('Type'=>'3'));
		
        /*
         *  Where condition
         */
         //$crud->where('sheikh_type','scientist');
         $crud->where('cattype',3);
         $crud->where('content.archived',0);
        /*
         *  Display fields as
         */
        $crud->display_as('catid',lang('following_to'));
        $crud->display_as('sheikh_id','العالم');
        $crud->display_as('name',lang('name_ar'));
        $crud->display_as('pic',lang('image'));
        $crud->display_as('file_path','الملف');
        $crud->display_as('file_size','حجم الملف');
        $crud->display_as('file_period','المدة');
        $crud->display_as('url_path','رابط');
        $crud->display_as('details','النص');
        $crud->display_as('viewitem',lang('activation'));
        
        /* 
         * Add this customisation for parent_relation 
         /
        $primary_id_field   = 'Category_id';        //$primary_id_field  is the primary key of your table
        $table_name 		= 'categories';         //$table_name is the name of our table
        $relation_field_name= 'catid';          //$relation_field_name  is the name of field in the first table related to second table 
        $parent_field 		= 'Parent_id';          //$parent_field   is the parent field name
        if($this->config->item('multi_lang')==0)
        {
            $title_field 	= 'Name';      //$title_field is the title field that you want to appear from the table
        }else{
            $title_field 	= 'Name_en';      //$title_field is the title field that you want to appear from the table
        }
        $title_display_as 	= lang('Name')  ;             //$title_display_as  the string that it will show
        $where			= array('Active'=>'1','Type'=>'1');//not required ----- condition
        $same_table 		= false; //not required, the default is false
        $crud->set_parent_relation($primary_id_field,$table_name,$parent_field,$title_field,$crud,$title_display_as,$relation_field_name,$where,$same_table);
        /* ------------------------------------------- */
		
		$crud->columns('name', 'catid','sheikh_id', 'viewitem');
        $crud->fields('name','catid','sheikh_id','details','viewitem','add_date','cattype');
        $crud->edit_fields ('name','catid','sheikh_id','details','viewitem','add_date','cattype');
        $crud->required_fields('name', 'catid','sheikh_id');
		$crud->callback_column('viewitem',array($this,'activevalue'));	
        //$crud->set_field_upload('pic', 'assets/uploads/');	
        $crud->set_field_upload('file_path', 'assets/uploads/');
        
        /*
         *  Hidden fields
         */
         //$crud->field_type('sheikh_type', 'hidden', 'scientist');        
         $crud->field_type('cattype', 'hidden', 3);       
         $crud->field_type('viewitem', 'hidden', 1);
         $crud->field_type('add_date', 'hidden', date('Y-m-d H:i:s' , mktime()));
         
        /*
         * Unset Functions
         */         
         $crud->unset_print();
         $crud->unset_export();
         

		if(@$this->session->userdata('perm')->{$this->uri->segment(2)}->{$this->uri->segment(2).'add'}!=1)
		{
			$crud->unset_add();
		}
		
		if(@$this->session->userdata('perm')->{$this->uri->segment(2)}->{$this->uri->segment(2).'edit'}!=1)
		{
			$crud->unset_edit();
		}
		
		if(@$this->session->userdata('perm')->{$this->uri->segment(2)}->{$this->uri->segment(2).'del'}!=1)
		{
			$crud->unset_delete();
		}
		
        $output = $crud->render();
        $this->_example_output($output);
			
    }
	
	function activevalue($value, $row)
	{
		if($value ==0)
		{
			return ;
		}elseif($value ==1) 
		{
			return   img(array('src'=>base_url().'assets/images/ok.png'));     
		}	
	}
}