<?php
if (!defined('BASEPATH'))
    exit('No direct script access allowed');
class Users extends CI_Controller
{
    function __construct()
    {
        parent::__construct();
        $this->init->admin_init();
		$this->init->get_perm();
		$this->load->library('crumb');
    }
    function _example_output($output = null)
    {
        //$output['breadcrumb'] = $this->load->crumb->get_crumbs(1,"/", lang('users'));
        $this->load->view('base/header', true);
        $this->load->view('base/grid',$output);
        $this->load->view('base/footer',true);
    }
    function index()
    {
        $crud = new grocery_CRUD();
        $crud->set_table('users');
		/*
         * Set subject
         */
        $crud->set_subject(lang('user'));
        /*
         *  Set rulse
         */
        /*
         *  Display fields as
         */
		$crud->display_as('username',lang('user_username'))
			->display_as('email',lang('user_email'))
			->display_as('group_id',lang('user_group_id'))
			->display_as('fullname',lang('user_fullname'))
			//->display_as('first_name',lang('user_first_name'))
			//->display_as('last_name',lang('user_last_name'))
			->display_as('job',lang('user_job'))
			->display_as('country',lang('user_country'))
			->display_as('active',lang('user_active'))
			->display_as('address',lang('user_address'))
			->display_as('password',lang('user_password'))
			->display_as('phone',lang('user_phone'))
			->display_as('trust',lang('user_trust_sign'));
        /*
         * Set relation
         */
        if($this->config->item('multi_lang')==0)
        {
            $crud->set_relation('country','countries','Name');
        }else{
            $crud->set_relation('country','countries','Nameen');
        }
        $crud->set_relation_n_n('group_id', 'users_groups', 'groups', 'user_id', 'group_id', 'name');
        /*
         *  Columns
         */
        if($this->session->userdata('adminlang') == 'arabic')
        {
            $crud->columns('fullname','username', 'email', 'active');
        }else{
            $crud->columns('fullname','username', 'email', 'active');
        }
        /*
         *  Fields
         */
        if($this->config->item('multi_language')==0)
        {
            $crud->fields('group_id','username', 'email','phone','fullname','password','active');
        }else{
            $crud->fields('group_id','username', 'email','phone','fullname','password','active');
        }
        /*
         *  Required fields
         */
        if($this->config->item('multi_language')==0)
        {
            $crud->required_fields('username', 'email', 'group_id','fullname');
        }else{
            $crud->required_fields('username', 'email', 'group_id','fullname');
        }
        /*
         *  Edit fields
         */
        if($this->config->item('multi_language')==0)
        {
            $crud->edit_fields ('group_id','username', 'email','phone','fullname','job','country','password','trust','active');
        }else{
            $crud->edit_fields ('group_id','username', 'email','phone','fullname','job','country','password','trust','active');
        }
        
        /*
         *  Hidden fields
         */
         
        /*
         *  Callback functions
         */
        ////////////////**log file
		$crud->callback_after_insert(array($this,'log_file_add'));
		$crud->callback_after_update(array($this,'log_file_edit'));
        $crud->callback_after_delete(array($this,'log_file_delete'));
        ///////////////////////////////////////////////////////////// 
        $crud->callback_edit_field('password', array($this,'set_password_input_to_empty'));
        $crud->callback_add_field('password', array($this, 'set_password_input_to_empty'));
        $crud->callback_column('active',array($this,'activevalue'));
        $crud->callback_column('trust',array($this,'activevalue'));
        $crud->callback_insert(array($this,'insert_callback'));
        $crud->callback_update(array($this,'update_callback'));
        $crud->callback_delete(array($this,'delete_callback'));
		/* 
        * Users Permissions
        */
        if(@$this->session->userdata('perm')->{$this->uri->segment(2)}->{$this->uri->segment(2).'add'}!=1)
		{
			$crud->unset_add();
		}
		if(@$this->session->userdata('perm')->{$this->uri->segment(2)}->{$this->uri->segment(2).'edit'}!=1)
		{
			$crud->unset_edit();
		}
		if(@$this->session->userdata('perm')->{$this->uri->segment(2)}->{$this->uri->segment(2).'del'}!=1)
		{
			$crud->unset_delete();
		}
        
        /*
         * Unset Functions
         */         
         $crud->unset_print();
         $crud->unset_export();
         
        $output = $crud->render();
        $this->_example_output($output);
    }
	function set_password_input_to_empty()
    {
        return "<input type='password' name='password' value='' />";
    }
	 function insert_callback($post_array)
    {
        $username = $post_array['username'];
        $password = $post_array['password'];
        $email = $post_array['email'];
        $group = $post_array['group_id'];
        //$group_name = $this->ion_auth->get_group($post_array['group_id'])->name;
        $additional_data = array(
            'first_name' => $post_array['first_name'],
            'last_name' => $post_array['last_name'],
            'mobile' => $post_array['mobile'],
            'phone' => $post_array['phone'],
            'address' => $post_array['address'],
            'trust' => $post_array['trust'],
            'active' => $post_array['active']
        );
        return $this->ion_auth->register($username, $password, $email, $additional_data, $group);
    }
	function delete_callback($primary_key)
    {
        $id = $primary_key;
        return $this->ion_auth->delete_user($id);
    }
    function update_callback($post_array, $primary_key)
    {
        $id = $primary_key;
        $data = array(
                'username' => $post_array['username'],
                'email' => $post_array['email'],
                'password' => $post_array['password'],
                'trust' => $post_array['trust'],
                'active' => $post_array['active'],
        );
		$this->ion_auth->update($id, $data);
        // this work ok but second code also work ok 
        //$this->ion_auth->remove_from_group(NULL, $id);
        //$group_id= $post_array['group_id'];
        //for($i=0;$i<count($group_id);$i++)
        //{
        //    $this->add_to_my_group($group_id[$i],$id);
        //}
        // this work ok but first code also work ok 
        $groupData = $this->input->post('group_id');
        if (isset($groupData) && !empty($groupData)) 
        {
            $this->ion_auth->remove_from_group('', $id);
			foreach ($groupData as $grp) 
            {
				$this->ion_auth->add_to_group($grp, $id);
            }
		}
    }
	function groups()
	{
		$crud = new grocery_CRUD();
        $crud->set_table('groups');
        $crud->set_subject(lang('groups'));
		$crud->display_as('name',lang('group_name'));
		$crud->display_as('description',lang('group_description'));
		//$crud->set_language(lang('Adminlang'));
		$crud->columns('name', 'description');
        $crud->fields('name','description');
        $crud->edit_fields ('name','description');
        $crud->required_fields('name', 'description');
		$crud->add_action(lang('Permissions'), base_url().'assets/images/ok.png', ADMIN_MODULE . '/users/permission','ui-icon-image');
		$crud->required_fields('name');
		$output = $crud->render();
		$this->_example_output($output);
	}
	function permission($ID)
	{
		$this->load->model('base_model');
		$body['modules'] = $this->load->base_model->get_modules();
		$body['permissions'] = json_decode($this->load->base_model->get_module_permission($ID,'Permissions'));
		$body['Group_type'] = $this->load->base_model->get_module_permission($ID,'Group_type');
		$body['ID'] = $ID;
		$body['breadcrumb'] = $this->load->crumb->get_crumbs(1,"/","dashboard");
        $data['js_files'][]=base_url().'assets/grocery_crud/js/jquery-1.8.2.min.js';
        //$bread['breadcrumb']='<a href="'.base_url().'Base/user">home</a>';
        $this->load->view('base/header',$data);
        $this->load->view('permissions',$body);
        $this->load->view('base/footer');
	}
	function save_permission()
	{
		$this->load->model('base_model');
		$Group_type = $this->input->post('Group_type');
		$group_id = $this->input->post('group_id');
		$modules = $this->load->base_model->get_modules();
			foreach ($modules as $m)
			{
            	$a[$m->U_name]=array($m->U_name."view" => $this->input->post($m->U_name.'view'),
									 $m->U_name."add"  => $this->input->post($m->U_name.'add'),
									 $m->U_name."edit" => $this->input->post($m->U_name.'edit'),
									 $m->U_name."del"  => $this->input->post($m->U_name.'del')
								);
			}
		//id 	name 	description 	Permissions 	Group_type
		$dat = json_encode($a);
		$data = array(
            'Permissions' => $dat,
            'Group_type' => $group_id
        );
		$this->db->where('id', $group_id);
		$this->db->update('groups', $data); 
		redirect(ADMIN_MODULE . '/users/groups');
	}
    function activevalue($value, $row)
	{
		if($value ==0)
		{
			return ;
		}elseif($value ==1) 
		{
			return   img(array('src'=>base_url().'assets/images/ok.png'));     
		}	
	}
    function log_file_add($row,$primary_key )
    {
		$data=array(
				   'user_id'=>$this->ion_auth->user()->row()->id,
				   'user_name'=>$this->ion_auth->user()->row()->username,
				   'operation'=>'إضافة',
				   'module_operation'=>'المستخدمين',
				   'operationen'=>'ADD',
				   'module_operationen'=>'Users',
				   'action_nameen'=>$row['username'],
				   'action_id'=>$primary_key,
				   'datee'=>mktime(),
				   'action_name'=>$row['username']
				   );			   
        $this->log_file->save($data);
    }
    function log_file_edit($row,$primary_key )
    {
		$data=array(
				   'user_id'=>$this->ion_auth->user()->row()->id,
				   'user_name'=>$this->ion_auth->user()->row()->username,
				   'operation'=>'تعديل',
				   'module_operation'=>'المستخدمين',
				   'operationen'=>'Edit',
				   'module_operationen'=>'Users',
				   'action_nameen'=>$row['username'],
				   'action_id'=>$primary_key,
				   'datee'=>mktime(),
				   'action_name'=>$row['username']
				   );			   
        $this->log_file->save($data);
    }
    function log_file_delete($primary_key )
    {
		$data=array(
				   'user_id'=>$this->ion_auth->user()->row()->id,
				   'user_name'=>$this->ion_auth->user()->row()->username,
				   'operation'=>'حذف',
				   'operationen'=>'Delete',
				   'module_operationen'=>'Users',
				   'module_operation'=>'المستخدمين',
				   'action_id'=>$primary_key,
				   'datee'=>mktime(),		   
				   );			   
        $this->log_file->save($data);
    }
}